package javax.swing.plaf.synth;

import java.awt.Insets;
import javax.swing.plaf.ComboBoxUI;
import java.awt.Rectangle;
import javax.swing.JComboBox;
import javax.swing.plaf.basic.BasicComboPopup;

class SynthComboPopup extends BasicComboPopup
{
    public SynthComboPopup(JComboBox combo) {
        super(combo);
    }
    
    @Override
    protected void configureList() {
        this.list.setFont(this.comboBox.getFont());
        this.list.setCellRenderer(this.comboBox.getRenderer());
        this.list.setFocusable(false);
        this.list.setSelectionMode(0);
        int selectedIndex = this.comboBox.getSelectedIndex();
        if (selectedIndex == -1) {
            this.list.clearSelection();
        }
        else {
            this.list.setSelectedIndex(selectedIndex);
            this.list.ensureIndexIsVisible(selectedIndex);
        }
        this.installListListeners();
    }
    
    @Override
    protected Rectangle computePopupBounds(int px, int py, int pw, int ph) {
        ComboBoxUI ui = this.comboBox.getUI();
        if ((ui instanceof SynthComboBoxUI)) {
            SynthComboBoxUI synthComboBoxUI = (SynthComboBoxUI)ui;
            if (synthComboBoxUI.popupInsets != null) {
                Insets popupInsets = synthComboBoxUI.popupInsets;
                return super.computePopupBounds(px + popupInsets.left, py + popupInsets.top, pw - popupInsets.left - popupInsets.right, ph - popupInsets.top - popupInsets.bottom);
            }
        }
        return super.computePopupBounds(px, py, pw, ph);
    }
}
